import * as Joi from 'joi';

var logger = require('./logger');
var app = require('./config/app');

let schema = {
  message_type: Joi.string().valid(app.messageTypes).insensitive().required(),
  current_index: Joi.number().integer(),
  total_questions: Joi.number().integer(),
  total_questions_answered: Joi.number().integer(),
  time_elapsed: Joi.number(),
  time_left: Joi.any(),
  status: Joi.string(),
  channel: Joi.string(),
  client: Joi.string(),
  client_type: Joi.string(),
  user_id: Joi.number().integer(),
  user_exam_id: Joi.number().integer(),
  user_name: Joi.string(),
  exam_title: Joi.string(),
  message: Joi.string(),
};

module.exports = {
  prepareMessage: (message: string) => {
    var parsed = JSON.parse(message)
    const result = Joi.validate(parsed, schema);

    if (result.error) {
      return result
    } else {
      return parsed
    }
  }
}
